package jp.sf.amateras.xmleditor.editors;

import jp.sf.amateras.xmleditor.XMLEditorPlugin;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.ui.editors.text.TextEditor;

public class XMLEditor extends TextEditor implements IPropertyChangeListener {

	private ColorManager colorManager;

	public XMLEditor() {
		super();
		colorManager = new ColorManager();
		setSourceViewerConfiguration(new XMLConfiguration(colorManager));
		setDocumentProvider(new XMLDocumentProvider());
		
		// ݒ̕ύXʒm󂯎邽߂̃Xio^
		IPreferenceStore store = XMLEditorPlugin.getDefault().getPreferenceStore();
		store.addPropertyChangeListener(this);
	}
	
	public void dispose() {
		colorManager.dispose();
		super.dispose();
		
		// ݒ̕ύXʒm󂯎邽߂̃Xi폜
		IPreferenceStore store = XMLEditorPlugin.getDefault().getPreferenceStore();
		store.removePropertyChangeListener(this);
	}

	public void propertyChange(PropertyChangeEvent event) {
		// ݒ̕ύXʒm
		XMLConfiguration config = (XMLConfiguration)getSourceViewerConfiguration();
		config.updatePreferences();
		// eLXgGfB^ĕ`
		getSourceViewer().invalidateTextPresentation();
	}

}
